#!/usr/bin/env ruby

require 'rubygems'
require 'rack'
require 'backrack'
require 'yaml'

require 'pp'

load_config = ["config/backrack.yml", "config/config.yml", "backrack.yml"].map{ |c|
   File.join(Dir.pwd, c)
}.select{|c| File.exists?(c)}.first

unless load_config
  puts "could not find config file #{load_config}"
  exit
end
Backrack.config.merge!(YAML.load_file(load_config))
Backrack.initialize!
Backrack.discover
Backrack.load_serializers
