# 
# To change this template, choose Tools | Templates
# and open the template in the editor.
 

class Backrack::Reloader
  def self.reload!
    Dir.glob(File.dirname(__FILE__)+"/*.rb") do |file|
      if @mtime[file] && (@mtime[file] != File.mtime(file))
        Backrack.logger.debug "reloading file #{file}"
        load file
        @mtime[file] = File.mtime(file)
      else
        @mtime[file]= File.mtime(file)
      end
    end
  end

  def self.reload_serializers
    Backrack.load_serializers(nil, true)
  end
    
  @mtime||= {}  
end
