# 
# To change this template, choose Tools | Templates
# and open the template in the editor.

require File.join(File.dirname(__FILE__), %w[spec_helper])
$: << File.join(File.split(File.dirname(__FILE__))[0..-2],'lib')

require 'backrack/mimeparse'
require 'pp'

describe MIMEParse do
  @@supported = [
    "text/xml;q=1", #0 
    "text/*;q=0.9", #1
    "application/json;q=1", #2 
    "text/javascript;q=0.7", #3
    "text/javascript", #4
    "*/*;q=0.1", #5
    "text/html;q=0.1", #6
  ]
    
  @@accepted = {
    "fake/type" => 5,
    "text/html" => 6, 
    "*/*" => 0, 
    "text/xml" => 0, 
    "*/json"=> 2, 
    "text/javascript" => 4,
    "text/xml;q=0.1, text/html;q=0.9" => 6, 
    
  }
  
  @@accepted.each do |mt, i|    
    expected = @@supported[i].dup
    supported = @@supported.dup
    it "should assign #{mt} to #{expected}" do
      result = MIMEParse.best_match(supported, mt)
      result.should eql(expected)
    end    
  end
end

