
class Initialization
  attr_accessor :a, :b
  def initialize(a,b)
    @a = a 
    @b = b
  end

  def foo
    "foo from Initialization"
  end  
  
  def old
    "old initializator :D"
  end
end

class FancyName < Initialization
  def self.echo(*echo)
    echo
  end
  
  def self.ping
    "pong"
  end
  
  def self.foo
    "foo from FancyName"
  end
  
  def foo
    "foo from FancyName"
  end
  
  def ping
    "pong"
  end
  
  def self.bar
    "class bar"
  end
  
  def bar
    "instance bar"
  end
  
  def self.test_array
    [2,3,'string',4]
  end
  
  def test_array
    [2,3,'string',4]
  end
  
  def self.test_hash(a1,b1)
    {a1=>b1}
  end
  
  def self.test_args(a1,b1,c1)
    [a1,b1,c1]
  end
  
  def self.raiser
    raise Exception.new("some_exception")
  end
  
  def test_special_params(session, request, response, params)
    assert session.kind_of?(Hash), "session is not kind of Hash"
    assert session.kind_of?(Session), "session is not kind of Backrack::Session"
    assert request.kind_of?(Rack::Request), "request is not Rack::Request"
    assert response.kind_of?(Rack::Response), "response is not Rack::Response"
    assert params.respond_to?(:'[]'), "params doesn't respond to []"
    "i'm ok"
  end
  
  def self.test_special_params(session, request, response, params)
    assert session.kind_of?(Hash), "session is not kind of Hash"
    assert session.kind_of?(Session), "session is not kind of Backrack::Session"
    assert request.kind_of?(Rack::Request), "request is not Rack::Request"
    assert response.kind_of?(Rack::Response), "response is not Rack::Response"
    assert params.respond_to?(:'[]'), "params doesn't respond to []"
    "i'm ok"
  end
  
  private
  def assert(truth, comment)
    raise Exception.new("there was problems with self test: "+comment) unless truth
  end
  
  def self.assert(truth, comment)
    raise Exception.new("there was problems with self test: "+comment) unless truth
  end
end

class Debugger
  def self.debug
    {
      :request => request,
      :params => params,
      :serializer => serializer,
      :response => response,
      :classes => Backrack::Parasite.classes,
      :post => request.POST,
      :get => request.GET,
      :content => request.env["CONTENT_TYPE"]
    }
  end
end
