
unless Class.new.respond_to?(:instance_methods_ex)
  class Class
    def instance_methods_ex
      list_methods = if defined?(Backrack.config) && Backrack.config[:no_inheritance]
        instance_methods(false) 
      else
        instance_methods - Object.instance_methods + instance_methods(false)
      end
    
      list_methods.inject({}) do |hash, method|
        sexp = ParseTree.new(false).parse_tree_for_method(self, method)
        params = sexp[2][1][1][1..-1] rescue []
        hash[method]= params.select{|pr| pr.class == Symbol}
        hash
      end
    end
    
    def metaclass
      if self.class == Class 
        class << self; self; end; 
      else
        self.class
      end     
    end
    
    def methods_ex
      methods = self.methods(false) + (self.methods & ["new", "instance"])
      methods.inject({}){|h, m|
        h[m] = self.method(m).params; h  
      }      
    end
  end
end