#!/usr/bin/env ruby
$: << File.expand_path(File.join(File.dirname(__FILE__), '..'))
$: << File.expand_path(File.join(File.dirname(__FILE__), '../lib'))
require 'rubygems'
require 'rack'
require 'lib/backrack'

require 'pp'

load_config = ["config/backrack.yml", "config/config.yml", "backrack.yml"].map{ |c|
   File.join(Dir.pwd, c)
}.select{|c| File.exists?(c)}.first

unless load_config
  puts "could not find cinfig file #{load_config}"
  exit
end
Backrack::Cfg.load_from_yaml(load_config)
Backrack.initialize!
Backrack.discover!
Backrack.load_serializers!
